Searcher (Lucene 3.6.2 API)
Keywords: org.apache.lucene.search.Searcher class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.search
Class Searcher

    java.lang.Object
      org.apache.lucene.search.Searcher

All Implemented Interfaces:
  Closeable, Searchable

Direct Known Subclasses:
  IndexSearcher, MultiSearcher

Deprecated. In 4.0 this abstract class is removed/absorbed into IndexSearcher

    @Deprecated
    public abstract class Searcher

extends Object
implements Searchable

An abstract base class for search implementations. Implements the main search methods.

Note that you can only access hits from a Searcher as long as it is not yet closed, otherwise an IOException will be thrown.

Constructor Summary
`Searcher()` Deprecated.

Method Summary
`abstract void` | `close()` Deprecated. Frees resources associated with this Searcher.
`Weight` | `createNormalizedWeight(Query query)` Deprecated. Creates a normalized weight for a top-level `Query`.
`protected Weight` | `createWeight(Query query)` Deprecated. never ever use this method in `Weight` implementations. Subclasses of Searcher should use `createNormalizedWeight(org.apache.lucene.search.Query)`, instead.
`abstract Document` | `doc(int i)` Deprecated. Returns the stored fields of document `i`.
`abstract Document` | `doc(int docid, FieldSelector fieldSelector)` Deprecated. Get the `Document` at the `n`th position.
`abstract int` | `docFreq(Term term)` Deprecated. Expert: Returns the number of documents containing `term`.
`int[]` | `docFreqs(Term[] terms)` Deprecated. Expert: For each term in the terms array, calculates the number of documents containing `term`.
`Explanation` | `explain(Query query, int doc)` Deprecated. Returns an Explanation that describes how `doc` scored against `query`.
`abstract Explanation` | `explain(Weight weight, int doc)` Deprecated. Expert: low-level implementation method Returns an Explanation that describes how `doc` scored against `weight`.
`Similarity` | `getSimilarity()` Deprecated. Expert: Return the Similarity implementation used by this Searcher.
`abstract int` | `maxDoc()` Deprecated. Expert: Returns one greater than the largest possible document number.
`abstract Query` | `rewrite(Query query)` Deprecated. Expert: called to re-write queries into primitive queries.
`void` | `search(Query query, Collector results)` Deprecated. Lower-level search API.
`void` | `search(Query query, Filter filter, Collector results)` Deprecated. Lower-level search API.
`TopDocs` | `search(Query query, Filter filter, int n)` Deprecated. Finds the top `n` hits for `query`, applying `filter` if non-null.
`TopFieldDocs` | `search(Query query, Filter filter, int n, Sort sort)` Deprecated. Search implementation with arbitrary sorting.
`TopDocs` | `search(Query query, int n)` Deprecated. Finds the top `n` hits for `query`.
`TopFieldDocs` | `search(Query query, int n, Sort sort)` Deprecated. Search implementation with arbitrary sorting and no filter.
`abstract void` | `search(Weight weight, Filter filter, Collector results)` Deprecated. Lower-level search API.
`abstract TopDocs` | `search(Weight weight, Filter filter, int n)` Deprecated. Expert: Low-level search implementation.
`abstract TopFieldDocs` | `search(Weight weight, Filter filter, int n, Sort sort)` Deprecated. Expert: Low-level search implementation with arbitrary sorting.
`void` | `setSimilarity(Similarity similarity)` Deprecated. Expert: Set the Similarity implementation used by this Searcher.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Searcher

    public Searcher()

  Deprecated.

Method Detail

### search

    public TopFieldDocs search(Query query,
                               Filter filter,
                               int n,
                               Sort sort)
                        throws IOException

  Deprecated.
  Search implementation with arbitrary sorting. Finds the top `n` hits for `query`, applying `filter` if non-null, and sorting the hits by the criteria in `sort`.

  NOTE: this does not compute scores by default; use `IndexSearcher.setDefaultFieldSortScoring(boolean, boolean)` to enable scoring.

  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### search

    public TopFieldDocs search(Query query,
                               int n,
                               Sort sort)
                        throws IOException

  Deprecated.
  Search implementation with arbitrary sorting and no filter.

  Parameters:
    `query` - The query to search for
    `n` - Return only the top n results
    `sort` - The `Sort` object
  Returns:
    The top docs, sorted according to the supplied `Sort` instance
  Throws:
    `IOException`

### search

    public void search(Query query,
                       Collector results)
                throws IOException

  Deprecated.
  Lower-level search API.

  `Collector.collect(int)` is called for every matching document.

  Applications should only use this if they need all of the matching documents. The high-level search API (`search(Query, int)`) is usually more efficient, as it skips non-high-scoring hits.

  Note: The `score` passed to this method is a raw score. In other words, the score will not necessarily be a float whose value is between 0 and 1.

  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### search

    public void search(Query query,
                       Filter filter,
                       Collector results)
                throws IOException

  Deprecated.
  Lower-level search API.

  `Collector.collect(int)` is called for every matching document.
  Collector-based access to remote indexes is discouraged.

  Applications should only use this if they need all of the matching documents. The high-level search API (`search(Query, Filter, int)`) is usually more efficient, as it skips non-high-scoring hits.

  Parameters:
    `query` - to match documents
    `filter` - if non-null, used to permit documents to be collected.
    `results` - to receive hits
  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### search

    public TopDocs search(Query query,
                          Filter filter,
                          int n)
                   throws IOException

  Deprecated.
  Finds the top `n` hits for `query`, applying `filter` if non-null.

  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### search

    public TopDocs search(Query query,
                          int n)
                   throws IOException

  Deprecated.
  Finds the top `n` hits for `query`.

  Throws:
    `BooleanQuery.TooManyClauses`
    `IOException`

### explain

    public Explanation explain(Query query,
                               int doc)
                        throws IOException

  Deprecated.
  Returns an Explanation that describes how `doc` scored against `query`.

  This is intended to be used in developing Similarity implementations, and, for good performance, should not be displayed with every hit. Computing an explanation is as expensive as executing the query over the entire index.

  Throws:
    `IOException`

### setSimilarity

    public void setSimilarity(Similarity similarity)

  Deprecated.
  Expert: Set the Similarity implementation used by this Searcher.

  See Also:
    `Similarity.setDefault(Similarity)`

### getSimilarity

    public Similarity getSimilarity()

  Deprecated.
  Expert: Return the Similarity implementation used by this Searcher.

  This defaults to the current value of `Similarity.getDefault()`.

### createNormalizedWeight

    public Weight createNormalizedWeight(Query query)
                                  throws IOException

  Deprecated.
  Creates a normalized weight for a top-level `Query`. The query is rewritten by this method and `Query.createWeight(org.apache.lucene.search.Searcher)` called, afterwards the `Weight` is normalized. The returned `Weight` can then directly be used to get a `Scorer`.

  Throws:
    `IOException`
  NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

### createWeight

    @Deprecated
    protected final Weight createWeight(Query query)
                                 throws IOException

  Deprecated. never ever use this method in `Weight` implementations. Subclasses of Searcher should use `createNormalizedWeight(org.apache.lucene.search.Query)`, instead.

  Expert: Creates a normalized weight for a top-level `Query`. The query is rewritten by this method and `Query.createWeight(org.apache.lucene.search.Searcher)` called, afterwards the `Weight` is normalized. The returned `Weight` can then directly be used to get a `Scorer`.

  Throws:
    `IOException`

### docFreqs

    public int[] docFreqs(Term[] terms)
                   throws IOException

  Deprecated.
  Description copied from interface: `Searchable`
  Expert: For each term in the terms array, calculates the number of documents containing `term`. Returns an array with these document frequencies. Used to minimize number of remote calls.

  Specified by:
    `docFreqs` in interface `Searchable`
  Throws:
    `IOException`

### search

    public abstract void search(Weight weight,
                                Filter filter,
                                Collector results)
                         throws IOException

  Deprecated.
  Description copied from interface: `Searchable`
  Lower-level search API.

  `Collector.collect(int)` is called for every document.
  Collector-based access to remote indexes is discouraged.

  Applications should only use this if they need all of the matching documents. The high-level search API (`search(Query,int)`) is usually more efficient, as it skips non-high-scoring hits.

  Specified by:
    `search` in interface `Searchable`
  Parameters:
    `weight` - to match documents
    `filter` - if non-null, used to permit documents to be collected.
    `results` - to receive hits
  Throws:
    `IOException`

### close

    public abstract void close()
                        throws IOException

  Deprecated.
  Description copied from interface: `Searchable`
  Frees resources associated with this Searcher. Be careful not to call this method while you are still using objects that reference this Searchable.

  Specified by:
    `close` in interface `Closeable`
  Specified by:
    `close` in interface `Searchable`
  Throws:
    `IOException`

### docFreq

    public abstract int docFreq(Term term)
                         throws IOException

  Deprecated.
  Description copied from interface: `Searchable`
  Expert: Returns the number of documents containing `term`.

  Specified by:
    `docFreq` in interface `Searchable`
  Throws:
    `IOException`
  See Also:
    `IndexReader.docFreq(Term)`

### maxDoc

    public abstract int maxDoc()
                        throws IOException

  Deprecated.
  Description copied from interface: `Searchable`
  Expert: Returns one greater than the largest possible document number.

  Specified by:
    `maxDoc` in interface `Searchable`
  Throws:
    `IOException`
  See Also:
    `IndexReader.maxDoc()`

### search

    public abstract TopDocs search(Weight weight,
                                   Filter filter,
                                   int n)
                            throws IOException

  Deprecated.
  Description copied from interface: `Searchable`
  Expert: Low-level search implementation. Finds the top `n` hits for `query`, applying `filter` if non-null.

  Applications should usually call `search(Query,int)` or `search(Query,Filter,int)` instead.

  Specified by:
    `search` in interface `Searchable`
  Throws:
    `IOException`

### doc

    public abstract Document doc(int i)
                          throws CorruptIndexException,
                                 IOException

  Deprecated.
  Description copied from interface: `Searchable`
  Returns the stored fields of document `i`.

  Specified by:
    `doc` in interface `Searchable`
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error
  See Also:
    `IndexReader.document(int)`

### doc

    public abstract Document doc(int docid,
                                 FieldSelector fieldSelector)
                          throws CorruptIndexException,
                                 IOException

  Deprecated.
  Description copied from interface: `Searchable`
  Get the `Document` at the `n`th position. The `FieldSelector` may be used to determine what `Field`s to load and how they should be loaded. NOTE: If the underlying Reader (more specifically, the underlying `FieldsReader`) is closed before the lazy `Field` is loaded an exception may be thrown. If you want the value of a lazy `Field` to be available after closing you must explicitly load it or fetch the Document again with a new loader.

  Specified by:
    `doc` in interface `Searchable`
  Parameters:
    `docid` - Get the document at the `n`th position
    `fieldSelector` - The `FieldSelector` to use to determine what Fields should be loaded on the Document. May be null, in which case all Fields will be loaded.
  Returns:
    The stored fields of the `Document` at the nth position
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error
  See Also:
    `IndexReader.document(int, FieldSelector)`, `Fieldable`, `FieldSelector`, `SetBasedFieldSelector`, `LoadFirstFieldSelector`

### rewrite

    public abstract Query rewrite(Query query)
                           throws IOException

  Deprecated.
  Description copied from interface: `Searchable`
  Expert: called to re-write queries into primitive queries.

  Specified by:
    `rewrite` in interface `Searchable`
  Throws:
    `IOException`

### explain

    public abstract Explanation explain(Weight weight,
                                        int doc)
                                 throws IOException

  Deprecated.
  Description copied from interface: `Searchable`
  Expert: low-level implementation method Returns an Explanation that describes how `doc` scored against `weight`.

  This is intended to be used in developing Similarity implementations, and, for good performance, should not be displayed with every hit. Computing an explanation is as expensive as executing the query over the entire index.

  Applications should call `explain(Query, int)`.

  Specified by:
    `explain` in interface `Searchable`
  Throws:
    `IOException`

### search

    public abstract TopFieldDocs search(Weight weight,
                                        Filter filter,
                                        int n,
                                        Sort sort)
                                 throws IOException

  Deprecated.
  Description copied from interface: `Searchable`
  Expert: Low-level search implementation with arbitrary sorting. Finds the top `n` hits for `query`, applying `filter` if non-null, and sorting the hits by the criteria in `sort`.

  Applications should usually call `search(Query,Filter,int,Sort)` instead.

  Specified by:
    `search` in interface `Searchable`
  Throws:
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD